import java.awt.Cursor;

import javax.swing.JButton;

public class InvestmentController extends Controller {

	//---------------------------------------------------
	//Ivars	

	private Investment model;
	private View view;

	//---------------------------------------------------
	//Constructors	

	public InvestmentController(Investment aModel, View aView) {
		super();
		this.model = aModel;
		this.view = aView;
	}

	//---------------------------------------------------
	//Getters

	public Investment getModel() {
		return model;
	}

	//---------------------------------------------------
	//Hooking Up Events	

	protected void hookUpEvents() {
		((JButton) this.get("calculateButton")).addActionListener(evt -> this.clickedGo());
	}

	//---------------------------------------------------
	//Framework Methods
	
	@Override
	/** apply the view values to the model */
	public void apply() {
		//input		
		this.getModel().setName(getFieldValue("nameField"));
		this.getModel().setDeposit(Double.valueOf(getFieldValue("depositField")));		
		this.getModel().setInterest(Double.valueOf(getFieldValue("interestField")));		
		this.getModel().setPeriods(Integer.valueOf(getFieldValue("periodsField")));		
		this.getModel().setTime(Integer.valueOf(getFieldValue("timeField")));		
	}	

	@Override
	/** refresh the view from the model */	
	public void refresh() {
		//output
		setFieldValue("balanceField", String.format("%.2f", this.getModel().computeBalance()));
		setFieldValue("totalInterestField", String.format("%.2f", this.getModel().computeTotalInterest()));		
	}
	
	@Override
	public View getView() {
		return this.view;
	}

	//---------------------------------------------------
	//Action Handlers

	public void clickedGo() {
		//JOptionPane.showMessageDialog(null, "Hello!", "Title", JOptionPane.INFORMATION_MESSAGE);
		try {
			this.view.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
			this.apply();
			this.refresh();
		} finally {
			this.view.setCursor(Cursor.getDefaultCursor());
		}

	}

}