import javax.swing.JButton;
import javax.swing.JPanel;

@SuppressWarnings("serial")

public class InvestmentView extends View {
	
	//---------------------------------------------------
	//Ivars	
	
	private InvestmentController controller;
	
	//---------------------------------------------------
	//Constructors	

	InvestmentView() {
		//The next line calls the one-arg constructor
		//this("MVC Example");
		super("Investment View");
		controller = new InvestmentController(new Investment(), this);		
	    JPanel outer = createVertGroup();		
				
		outer.add(this.createFieldGroup());		
		
		//Action Buttons
		JPanel buttonBar = this.createButtonGroup();
		outer.add(buttonBar);		
				
		this.add(outer);
		this.setBounds(900, 500, 400, 500);
		this.setVisible(true);
		
		this.controller.hookUpEvents();
		this.controller.refresh();		
	}
	
	//---------------------------------------------------
	//Building View Groups
	
	private JPanel createFieldGroup() {
		//Fields
		JPanel fields = createVertGroup();
		fields.add(createField(this, "nameField", "Name", true));
		fields.add(createField(this, "depositField", "Deposit ($)", true));		
		fields.add(createField(this, "interestField", "Interest (%)", true));
		fields.add(createField(this, "periodsField", "Periods (Per Year)", true));
		fields.add(createField(this, "timeField", "Investment Duration (Years)", true));
		
		fields.add(createField(this, "balanceField", "Balance ($)", false));
		fields.add(createField(this, "totalInterestField", "Total Interest Gained ($)", false));
		return fields;
	}		
	
	private JPanel createButtonGroup() {
		JPanel buttons = createHorizGroup();
		JButton button = new JButton("Calculate");
		button.setName("calculateButton");
		buttons.add(button);
		return buttons;
	}	
	
	//---------------------------------------------------
	//Main (Program Launch Point / Entry Point)	
	
	public static void main(String args[]) {
		new InvestmentView();
	}
}